* cogenerator and utility ; simple model
* demand is given
* no utility planning ; CO2 emission coefficient of elec is fixed
* dummy demand and price data for template
* Two stage model ; consumers minimizes costs and then utility minimizes costs
* Consumer group ; prefecture, region and owner
* 2015 12 03 expanded -- thermal transportation between next regions
* 2015 12 07 expanded -- thermal transportation by type : chilled and hot water
* 2015 12 21 thermal source from water based is included
* 2018 11 20 modified
* 2019 5 24 Weather expansion according to Kishimoto model
* 2019 5 27 blackout case added
* 2019 5 28 dynamic region set

* power generation types for expansion

sets
  g   generation types    /gas, GCC, oil, coal, Nuc, RNW/
;

* energy units  Gcal and Gcal/h elec and thermal
* Demands ; room heating  (rh)
*           room cooling  (rc)
*           hot water     (hw)
*           other heating (ho)
*           other electric power demand (eo)
*           other electric power demand (ep)
*           other users (industry) (D_E_oth)

*   electric power supply options
*           utility
*           cgs
*   room heating options
*           cgs output heat and heat exchanger
*           gas room heater
*           heat pump
*   room cooling options
*           cgs output heat and absorption refrigerator
*           heat pump
*   hot water supply options
*           cgs output heat and heat exchanger
*           gas boiler


sets
  i hours /1*24/
  k  players /dh,ah,hos,co,sp,hot,ofH,ofL,DHC/
  c(k) consumers / dh,ah,hos,co,sp,hot,ofH,ofL /
  j7 categories / Summer_P,Summer_WD,Summer_HD,Winter_WD,Winter_HD,Middle_WD,Middle_HD/

  CR(c) /dh, ah/
  CB(c) /hos,co,sp,hot,ofH,ofL /

* 2019 5 24

  j categories / Summer_P,Summer_WD_F,Summer_HD_F,Middle_WD_F,Middle_HD_F,Winter_WD_F,Winter_HD_F,Summer_WD_C,Summer_HD_C,Middle_WD_C,Middle_HD_C,Winter_WD_C,Winter_HD_C,Summer_WD_R,Summer_HD_R,Middle_WD_R,Middle_HD_R,Winter_WD_R,Winter_HD_R, BlkOut/

  SmrDays(j) /Summer_P, Summer_WD_F, Summer_HD_F, Summer_WD_C, Summer_HD_C, Summer_WD_R, Summer_HD_R/


  r0 regions /1*151/
  r(r0)      /1*151/

  T0 periods  /1*5/
  T(t0)       /1*1/

  rx(r)
;

rx(r)=yes;

Alias(r0,rr0);
Alias(r,rr);
Alias(rx, rxr);

Table Jex(j, j7)
                Summer_P        Summer_WD       Summer_HD       Winter_WD       Winter_HD       Middle_WD       Middle_HD
Summer_P        1
Summer_WD_F                     1
Summer_HD_F                                     1
Middle_WD_F                                                                                     1
Middle_HD_F                                                                                                     1
Winter_WD_F                                                     1
Winter_HD_F                                                                     1
Summer_WD_C                     1
Summer_HD_C                                     1
Middle_WD_C                                                                                     1
Middle_HD_C                                                                                                     1
Winter_WD_C                                                     1
Winter_HD_C                                                                     1
Summer_WD_R                     1
Summer_HD_R                                     1
Middle_WD_R                                                                                     1
Middle_HD_R                                                                                                     1
Winter_WD_R                                                     1
Winter_HD_R                                                                     1
BlkOut                          1
;

** ambient temperature

Table Summer_T(i,j)
        Summer_P        Summer_WD_F     Summer_HD_F     Summer_WD_C     Summer_HD_C     Summer_WD_R     Summer_HD_R
1       26.90000000     25.87727273     25.87727273     25.87727273     25.87727273     25.80000000     25.80000000
2       27.60000000     25.85000000     25.85000000     25.85000000     25.85000000     25.52500000     25.52500000
3       27.80000000     25.65454545     25.65454545     25.65454545     25.65454545     25.72500000     25.72500000
4       27.70000000     25.46363636     25.46363636     25.46363636     25.46363636     25.57500000     25.57500000
5       28.20000000     25.43636364     25.43636364     25.43636364     25.43636364     25.12500000     25.12500000
6       28.30000000     25.72727273     25.72727273     25.72727273     25.72727273     25.21250000     25.21250000
7       28.90000000     26.50909091     26.50909091     26.50909091     26.50909091     25.70000000     25.70000000
8       30.10000000     27.18181818     27.18181818     27.18181818     27.18181818     26.42500000     26.42500000
9       32.20000000     27.59909091     27.59909091     27.59909091     27.59909091     27.27500000     27.27500000
10      35.10000000     29.01363636     29.01363636     29.01363636     29.01363636     27.45000000     27.45000000
11      35.10000000     29.79090909     29.79090909     29.79090909     29.79090909     28.21250000     28.21250000
12      36.70000000     30.49545455     30.49545455     30.49545455     30.49545455     27.91250000     27.91250000
13      37.60000000     30.69545455     30.69545455     30.69545455     30.69545455     28.47500000     28.47500000
14      33.40000000     29.55909091     29.55909091     29.55909091     29.55909091     27.80000000     27.80000000
15      31.10000000     29.84545455     29.84545455     29.84545455     29.84545455     28.27500000     28.27500000
16      30.70000000     29.30000000     29.30000000     29.30000000     29.30000000     27.43750000     27.43750000
17      31.10000000     28.70454545     28.70454545     28.70454545     28.70454545     27.18750000     27.18750000
18      34.00000000     28.25454545     28.25454545     28.25454545     28.25454545     26.38750000     26.38750000
19      33.70000000     27.68636364     27.68636364     27.68636364     27.68636364     26.28750000     26.28750000
20      33.60000000     27.27727273     27.27727273     27.27727273     27.27727273     26.43750000     26.43750000
21      32.90000000     26.93181818     26.93181818     26.93181818     26.93181818     26.26250000     26.26250000
22      31.80000000     26.58636364     26.58636364     26.58636364     26.58636364     26.23750000     26.23750000
23      31.30000000     26.29545455     26.29545455     26.29545455     26.29545455     26.18750000     26.18750000
24      30.50000000     26.00909091     26.00909091     26.00909091     26.00909091     26.08750000     26.08750000
;

** blackout in Summer_WD_F
** Winter_Holiday_Clpudy 0 -> 1 for calculation

parameter j_days(j)
/
  Summer_P 3
  Summer_WD_F 45
  Summer_HD_F 16
  Middle_WD_F 73
  Middle_HD_F 41
  Winter_WD_F 52
  Winter_HD_F 24
  Summer_WD_C 5
  Summer_HD_C 2
  Middle_WD_C 14
  Middle_HD_C 4
  Winter_WD_C 2
  Winter_HD_C 1
  Summer_WD_R 11
  Summer_HD_R 12
  Middle_WD_R 36
  Middle_HD_R 15
  Winter_WD_R 6
  Winter_HD_R 6
  BlkOut      1
/;



parameter i_hours(i);
  i_hours(i)= 1 ;

$include HLoffice_CGS_LCS_Koto151_j7.dat

$include HLoffice_Solar_LCS_Koto151_j7.dat

** 2019 5 22 MW -> kW

Parameter Solar_PWr(r0,c,i,j);
  Solar_PWr(r0,c,i,j)=sum(j7, Jex(j,j7)*Solar_Tokyo7(i,j7));

PV_Area(r0,c)=PV_Area(r0,c)*1000.0;

* power transportation among regions

$include KotoTrs.dat

* waste heat utilization

$include WST_LCS_w2015_koto151_j7.dat

** 2019 5 22 MW -> kW

parameter W_HT_1(t,r0,i,j);
  W_HT_1(t,r0,i,j)=sum(j7, Jex(j,j7)*W_HT_10_j7(r0,i,j7))*1000;

$include MWst_Wtr2015_Koto151A_j7.dat

** 2019 5 22 MW -> kW

parameter WTR_HT_10(r0,i,j);
   WTR_HT_10(r0,i,j)=sum(j7, Jex(j,j7)*WTR_HT_10_j7(r0,i,j7))*1000.;

** 2016 1 8 windpower supply added WndPwr(r0,i,j)

$include WindPower_Koto151_j7.dat

** 2019 5 22 MW -> kW
Parameter WndPwr(r0,i,j);

  WndPwr(r0,i,j)=sum(j7, Jex(j,j7)*WndPwr_j7(r0,i,j7))*1000.0;

** 2017 11 22 Subway supply added SW_HT_10(r0,i,j)

$include Subway_Koto151R_j7.dat

** 2019 5 22 MW -> kW
Parameter SW_HT_10(r0,i,j);

  SW_HT_10(r0,i,j)=sum(j7, Jex(j,j7)*SW_HT_10_j7(r0,i,j7))*1000.;

Parameter RV_H_Rto(r0)
/
$include RiverSrc_koto.dat
/;

**2016 12 16    Gd_H_UpperLimit per hour by Tejima -- kW/Collection Heat quantity 310W/m -> 200W/m ,Depth 20m ,interval 6m

Parameter Gd_H_UL(r0)
/
$include GdHP_UpLimit_koto.dat
/;

** MW -> kW

Gd_H_UL(r0)=Gd_H_UL(r0)/1e3*200/310;

display Gd_H_UL;


parameters

 D_rc(t,r,c,i,j)
 D_rh(t,r,c,i,j)
 D_hw(t,r,c,i,j)
 D_eo(t,r,c,i,j)
 D_ep(t,r,c,i,j)
;

** electricity -- kWh -> MWh -> kWh
** other thermal energy -- kJ ->MWh ->kWh

 D_rc(t,r,c,i,j)= sum(j7,Jex(j,j7)*D_rc7_1(r,c,i,j7))*1e-3/3.6;
 D_rh(t,r,c,i,j)= sum(j7,Jex(j,j7)*D_rh7_1(r,c,i,j7))*1e-3/3.6;
 D_hw(t,r,c,i,j)= sum(j7,Jex(j,j7)*D_hw7_1(r,c,i,j7))*1e-3/3.6;
 D_eo(t,r,c,i,j)= sum(j7,Jex(j,j7)*D_eo7_1(r,c,i,j7));
 D_ep(t,r,c,i,j)= sum(j7,Jex(j,j7)*D_ep7_1(r,c,i,j7));

Parameter Smr_Deg(i)
/
1       0.909128351
2       0.946878768
3       0.796685527
4       0.731849
5       0.692634788
6       0.499259528
7       0.629516375
8       0.617723706
9       0.693755021
10      0.883718096
11      1.145368053
12      1.461579124
13      1.495137895
14      1.220003776
15      1.155600329
16      1.425772501
17      1.199647289
18      1.351917275
19      1.294192355
20      1.23893168
21      1.101582281
22      1.008642065
23      0.820051059
24      0.680425157
/;


Scalar
  Rc_deg /0.4/
  Hot_Smr /2.0/;

 D_rc(t,r,c, i, "Summer_WD_C")=  D_rc(t,r,c, i, "Summer_WD_F")*Smr_Deg(i)*(1 - Rc_deg* 0.5);
 D_rc(t,r,c, i, "Summer_HD_C")=  D_rc(t,r,c, i, "Summer_HD_F")*Smr_Deg(i)*(1 - Rc_deg* 0.5);

 D_rc(t,r,c, i, "Summer_WD_R")=  D_rc(t,r,c, i, "Summer_WD_F")*Smr_Deg(i)*(1 - Rc_deg* 0.7);
 D_rc(t,r,c, i, "Summer_HD_R")=  D_rc(t,r,c, i, "Summer_HD_F")*Smr_Deg(i)*(1 - Rc_deg* 0.7);

 D_rc(t,r,c, i, SmrDays)=  D_rc(t,r,c, i, SmrDays)*Smr_Deg(i)*(1+ Rc_deg*Hot_Smr);

 D_rc(t,r,c,i,"BlkOut")$( (ord(i) ge 10) and (ord(i) le 18))=  D_rc(t,r,c,i,"Summer_WD_F")* 0.5;
 D_rh(t,r,c,i,"BlkOut")$( (ord(i) ge 10) and (ord(i) le 18))=  D_rh(t,r,c,i,"Summer_WD_F")* 0.2;
 D_hw(t,r,c,i,"BlkOut")$( (ord(i) ge 10) and (ord(i) le 18))=  D_hw(t,r,c,i,"Summer_WD_F")* 0.2;
 D_eo(t,r,c,i,"BlkOut")$( (ord(i) ge 10) and (ord(i) le 18))=  D_eo(t,r,c,i,"Summer_WD_F")* 0.7;


** 2019 5 29 ZEB and ZEH scenario

Scalars
 RD_ZEB /0.5/
 RD_ZEH /0.2/

 RT_ZEB /0.55/
 RT_ZEH /0.42/
;


 D_rc(t,r,cR,i,j)=  D_rc(t,r,cR,i,j)*(1.0-RD_ZEH*RT_ZEH);
 D_rh(t,r,cR,i,j)=  D_rh(t,r,cR,i,j)*(1.0-RD_ZEH*RT_ZEH);
 D_hw(t,r,cR,i,j)=  D_hw(t,r,cR,i,j)*(1.0-RD_ZEH*RT_ZEH);
 D_ep(t,r,cR,i,j)=  D_ep(t,r,cR,i,j)*(1.0-RD_ZEH*RT_ZEH);
                  
 D_rc(t,r,cB,i,j)=  D_rc(t,r,cB,i,j)*(1.0-RD_ZEB*RT_ZEB);
 D_rh(t,r,cB,i,j)=  D_rh(t,r,cB,i,j)*(1.0-RD_ZEB*RT_ZEB);
 D_hw(t,r,cB,i,j)=  D_hw(t,r,cB,i,j)*(1.0-RD_ZEB*RT_ZEB);
 D_ep(t,r,cB,i,j)=  D_ep(t,r,cB,i,j)*(1.0-RD_ZEB*RT_ZEB);
                  


Table x_prc_0(t0,i)     k\ per MWh wheeling price (sales from CGS to utility)
   1       12
1  5.0     3.0
2  5.0     3.0
3  5.0     3.0
4  5.0     3.0
5  5.0     3.0
;

** 2019 9 23 revised

Table y_prc_0(i, t0)
         1
1        11.82
2        11.82
3        11.82
4        11.82
5        11.82
6        11.82
7        19.52
8        19.52
9        19.52
10       19.52
11       19.52
12       19.52
13       19.52
14       19.52
15       19.52
16       19.52
17       19.52
18       19.52
19       19.52
20       19.52
21       19.52
22       19.52
23       11.82
24       11.82

;

parameters
 x_prc(t,i,j)
 y_prc(t,k,i,j)
 s_prc(t,i,j)     k\ per MWh electricity sales price to utility

;

** 2015 12 08 expanded
** thermal energy transportation cost -> these should be set according to the subsidies
* k\ per MWh -- but this number largely varies according to the construction costs
* Therefore these should be varied from 5 yen / kwh to 50000 yen / kwh
* Then the potentials of heat transportation would be analyzed.

Parameter
 Hw_prc(t,i,j)
 Cw_prc(t,i,j)
;

 Hw_prc(t,i,j)= 5.0;
 Cw_prc(t,i,j)= 5.0;

 x_prc(t,i,j)$(ord(i) le 11) = x_prc_0(t,"1");
 x_prc(t,i,j)$(ord(i) ge 12) = x_prc_0(t,"12");

 y_prc(t,k,i,j)= y_prc_0(i,t );

 y_prc(t,"ofH",i,j)= 26.0;
 y_prc(t,"ofL",i,j)= 26.0;
 y_prc(t,"hot",i,j)= 26.0;
 y_prc(t,"co",i,j) = 26.0;


*di

*  s_prc(t,i,j)=33;

   s_prc(t,i,j)=y_prc_0(i, t)*0.5;

positive variable
 y(t,r,c,i,j)        electric power supply from utility

 x_g(t,r,k,i,j)      gas supply for CGS generation
 x_cap(t,r,k)        CGS capacity

 x_c_ex(t,r,k,i,j)     export of CGS electric power of players
 x_c_im(t,r,k,i,j)     import of CGS electirc power of players 2008 12 10

 TD_el_spl(t,i,j)

 D_gbo(t,r,i,j)        gas supplu for DHC boiler

 D_c_im(t,r,c,i,j)     import of cold water from DHC
 D_hr_im(t,r,c,i,j)    import of hot water for heating from DHC
 D_hw_im(t,r,c,i,j)    import of hot water from DHC

 g_hr(t,r,c,i,j)       gas room heating supply
 g_hr_cap(t,r,c)       gas heater system capacity

 g_hw(t,r,c,i,j)       gas hot water supply
 g_abs(t,r,c,i,j)      gas heat for absorbtion cooler
 g_bo_cap(t,r,k)       gas boiler capacity

 D_gbo_cap(t,r)

 HP_cr(t,r,c,i,j)      elec Heat pump room cooling supply
 HP_hr(t,r,c,i,j)      elec Heat pump room heating supply
 HP_cap(t,r,c)         air-conditioner capacity



** 2016 12 22 c -> k DHC can have river based facilities

 RvHP_cr(t,r,k,i,j)    river based  elec Heat pump room cooling supply
 RvHP_hr(t,r,k,i,j)    river based  elec Heat pump room heating supply
 RvHP_cap(t,r,k)       river based  air-conditioner capacity

**2016 12 16    expanded

 GdHP_cr(t,r,k,i,j)    ground based  elec Heat pump room cooling supply
 GdHP_hr(t,r,k,i,j)    ground based  elec Heat pump room heating supply
 GdHP_cap(t,r,k)       ground based  air-conditioner capacity

**2017 11 22    expanded


 SwHP_hr(t,r,c,i,j)    subway based  elec Heat pump room heating supply
 SwHP_cr(t,r,c,i,j)    subway based  elec Heat pump room heating supply
 SwHP_cap(t,r,c)       subway based  air-conditioner capacity

 Absc_cr(t,r,k,i,j)    absorbtion refrigerator supply
 Absc_cap(t,r,k)       absorbtion refrigerator capacity

** 2014 11 19 expanded

 PV_cap(t,r,c)          PV area 2011 11 24 in 1000 m2
 PVN_cap(t,r,c)         newly installed PV area 2014 11 19 expanded
 PV_Fcost(t,r,c)        PV fixed cost

 HX(t,r,k)             capacity of heat exchanger

 c_h_hw(t,r,c,i,j)     hot water from CGS
 c_h_rh(t,r,c,i,j)     room heating from CGS
 c_h_rc(t,r,c,i,j)     room cooling from CGS or absorption rf

 HW_tr_cap(t,r,c)      hot water transportation capacity
 CW_tr_cap(t,r,c)      cold water transportation capacity

 gas_d(t,r,k,i,j)      gas demand


* 2011 11 24 Shimomura

 SolarPW(t,r,c,i,j)

** 20151203 heat transportation among regions
** heat transportation among DHC
** 2015 12 08 expanded
** hot and chilled water transportation

 HW_Trnsp(t,r,rr,i,j)    hot water transportation
 CW_Trnsp(t,r,rr,i,j)    chilled water transportation

 D_HW_GEN(t,r,i,j)  hot water generation of DHC

* D_CW_GEN(t,r,i,j)  chilled water generation of DHC -- included in Absc_cr(t,r,k,i,j)

** 2015 12 21 expanded for DHC heat pump

 DHP_cr(t,r,i,j)      DHC elec for Heat pump room cooling supply
 DHP_hr(t,r,i,j)      DHC elec for Heat pump room heating supply
 DHP_cap(t,r)         DHC Heat pump capacity

;

** DHP_cr.FX(t,r,i,j)=0.0;    for Trurumi

 HW_Trnsp.FX(t,r,rr,i,j)$(Heat_Rgn(r,rr) LT 1)=0.0;
 HW_Trnsp.FX(t,r,rr,i,j)$(Heat_Rgn(r,rr) GE 2)=0.0;

 CW_Trnsp.FX(t,r,rr,i,j)$(Heat_Rgn(r,rr) LT 1)=0.0;
 CW_Trnsp.FX(t,r,rr,i,j)$(Heat_Rgn(r,rr) GE 2)=0.0;

 scalar HwTrs_Eff /0.8/;
 scalar CwTrs_Eff /0.8/;

* 2015 12 17 waste power generation

Positive variables
  D_WST_H(t,r,i,j)  waste heat for elec generation
  D_WST_E(t,r,i,j)  waste heat for heat distribution
;
**

variables
 Cnsm_cost(t,r,c)
 DHC_cost(t,r)

 Cnsm_CO2(t,r,c)
 DHC_CO2(t,r)
;


 PV_cap.UP(t,r,c)=PV_Area(r,c);

variable

 T_Cost(t,r)        social welfare
 T_CO2(t,r)
 T_OBJ
;

scalars

c_el_eff  cgs electric power generation efficiency  /0.4/
c_h_eff   cgs heat supply efficiency                /0.45/
c_hx_eff  cgs heat exchanger efficiency             /0.9/

D_el_eff  DHC electric power generation efficiency  /0.4/
D_h_eff   DHC heat supply efficiency                /0.45/
D_hx_eff  DHC heat exchanger efficiency             /0.95/
D_gbo_eff DHC gas boiler efficiency                 /0.95/

COP_cc_abs COP of absorbtion refrigerator            /0.7/
COP_Dc_abs COP of absorbtion refrigerator            /0.7/

g_hr_eff   gas room heater efficiency               /0.9/
g_bo_eff   gas hot water supply efficiency          /0.9/

COP_h_HP  COP of heat pump for heating              /3.6/
COP_c_HP  COP of heat pump for cooling              /4.7/

trns_D_loss inverse transmission loss from DHC       /0.96/

 ht_eff   hot and cold water transportation efficiency  /0.8/

 CO2_gas   gas CO2 emission unit tC per MWh      /0.050/

 wgt_co2    weight for CO2                          /0.0/

** 2015 12 21 HP for DHC included

 COP_Dh_HP  COP of heat pump for DHC heating              /4.0/
 COP_Dc_HP  COP of heat pump for DHC cooling              /4.0/

** 2016 12 13 HP for river source air conditioning
 COP_h_RvHP  COP of heat pump for heating              /4.7/
 COP_c_RvHP  COP of heat pump for cooling              /5.5/



** 2016 12 16 HP for ground source air conditioning/4.3,6.0/10.0,10.0
 COP_h_GdHP  COP of heat pump for heating              /4.3/
 COP_c_GdHP  COP of heat pump for cooling              /6.0/

** 2017 11 22 HP for Subway source air conditioning
 COP_h_SwHP  COP of heat pump for heating              /5.0/
 COP_c_SwHP  COP of heat pump for heating              /5.2/
;

parameters
 cgs_el_ef(r,k)
 cgs_ht_ef(r,k)
 cgs_hx_ef(r,k)

 COP_c_abs(r,k)
;

 COP_c_abs(r,c)=COP_cc_abs;
 COP_c_abs(r,"DHC")=COP_Dc_abs;

 cgs_el_ef(r,c)=c_el_eff;
 cgs_el_ef(r,"DHC")=D_el_eff;

 cgs_ht_ef(r,c)=c_h_eff;
 cgs_ht_ef(r,"DHC")=D_h_eff;

 cgs_hx_ef(r,c)=c_hx_eff;
 cgs_hx_ef(r,"DHC")=D_hx_eff;


parameters

CO2_Elec(t,r,i,j)  CO2 emission tC per Gcal

CO2_gen(g)   CO2 emission tC per MWh by Fujii
/
 gas  0.1279
 GCC  0.1061
 oil  0.1773
 coal 0.2266
/
;

* initital assumption 2:00-6:00  oil; others gas
* this should be provided by power generation expansion model

set i_night(i) /2*6/;

 CO2_Elec(t,r,i,j)=CO2_gen("gas");
 CO2_Elec(t,r,i_night,j)=CO2_gen("gas");


display CO2_elec, cgs_el_ef ;

* original 1000yen per Mcal per hour for fixed cost
* Shimomura model 1,000,000 yen per MW for fixed cost
* variable cost 1000 yen per MWh
* fixed cost of PV should be checked 2011 11 24
* fixed cost -- per year payment ; annual rate already considered

scalars
x_FC    fixed cost of CGS           /50.0/
d_FC    fixed cost of DHC           /35.0/

gh_FC   fixed cost of gas heater    /0.18/
gb_FC   fixed cost of gas boiler    /1.5/

HP_FC   fixed cost of heat pump     /10.0/
ABS_FC  fixed cost of absorption refrigerator /3.8/



**2016 12 16 RvHP_FC /9.0 changed to 9.1/ considering North_Toyama
**2016 12 20 RvHP_FC /9.1 changed to 5.3/ considering Hakozaki

RvHP_FC tentative annual fixed cost /5.3/

**2016 12 19 GdHP_FC    expanded

GdHP_FC tentative annual fixed cost /5.8/

SwHP_FC tentative annual fixed cost /4.06/





HX_FC   fixed cost of heat exchanger /1.3/

gas_CVC   price of gas for consumer   /12.5/
gas_DVC  price of gas for DHC         /8.7/


HTR_FC  fixed cost of heat transportation  /0.86/
HTR_VC  variable cost of heat transportation /0.0086/


* PV cost million yen per year per 1000 m2
* PV_FC0   fixed cost of PV in million yen per 1000m2 /2.75/

 DHP_FC   tentative fixed cost of DHC heat pump      /8.0/

;

** 2015 12 17 waste generation eff

Parameter WST_E_eff(r0)
/
*98   0.086
63   0.0017
150   0.0632
/
;


* PV cost million yen per year per 1000 m2

*$ONTEXT
* PV Sanshou scenario

parameter  PV_FC(t0);
PV_FC(t0)=2.75;

parameter
  gas_VC(t,r,k)

* 2019 9 20 expanded

  gas_VCC(k)

/
 ofL 9.77
 ofH 6.27
 co  9.77
 sp  9.77
 hos 9.77
 hot 6.27
 dh 13.65
 ah 13.65
 DHC 5.36
/
;

  gas_VC(t,r,k)=gas_VCC(k);

equations
 x_capacity(t,r,k,i,j)      cgs capacity balance

 gh_capacity(t,r,c,i,j)     gas heater capacity balance
 gb_capacity(t,r,c,i,j)     gas boiler capacity balance

 Dgb_capacity(t,r,i,j)      DHC gas boiler capacity balance

 HP_rh_cap(t,r,c,i,j)       heat pump heating capacity balance
 HP_rc_cap(t,r,c,i,j)       heat pump cooling capacity balance

 RvHP_rh_cap(t,r,k,i,j)     river heat pump heating capacity balance
 RvHP_rc_cap(t,r,k,i,j)     river heat pump cooling capacity balance

** 2016 12 19 expanded for ground by Tejima

 GdHP_rh_cap(t,r,k,i,j)     river heat pump heating capacity balance
 GdHP_rc_cap(t,r,k,i,j)     river heat pump cooling capacity balance

SwHP_rh_cap(t,r,c,i,j)     subway heat pump heating capacity balance
SwHP_rc_cap(t,r,c,i,j)     subway heat pump heating capacity balance





** 2015 12 21 DHC capacity balance
 DHP_rh_cap(t,r,i,j)       DHC heat pump heating capacity balance
 DHP_rc_cap(t,r,i,j)       DHC heat pump cooling capacity balance

* DHP_rh_UP(t,r,i,j)       DHC heat pump heating supply limit
* DHP_rc_UP(t,r,i,j)       DHC heat pump cooling supply limit

 DHP_rhc_UP(t,r,i,j)       DHC heat pump cooling supply limit
 SW_rhc_UP(t,r,c,i,j)
 HX_capacity(t,r,k,i,j)     heat exchanger capacity balance

 Abs_capacity(t,r,k,i,j)    absorption refrigerator balance

 elec_bal(t,r,c,i,j)     electric power demand balance
 gas_bal(t,r,c,i,j)      gas demand balance

 D_elec_bal(t,r,i,j)     DHC electric power demand balance
 Dgas_bal(t,r,i,j)       DHC gas demand balance

 T_elec_bal(t,i,j)      2008 12 10  total DHC elec balance


* 2014 11 13 expanded

 PV_cap_def(t, r, c)       PV capacity expansion
 PV_FC_def(t,r,c)          PV fixed cost definition
 PV_FCi_def(r,c)           initial PV fixed cost definition

 cgs_e_ex(t,r,c,i,j)       cgs elec export constraint

 Dgs_e_ex(t,r,i,j)         DHC elec export constraint

 cgs_heat_bal(t,r,c,i,j)  CGS heat balance




** 2015 12 08 expanded DHC thermal transportation divided into HW and CW

 DHC_heat_gen(t,r,i,j)    DHC heat generation balance

 DHC_HW_bal(t,r,i,j)   DHC hot water supply  balance
 DHC_CW_bal(t,r,i,j)   DHC chilled water suppply balance



 hr_bal(t,r,c,i,j)       room heating balance
 hc_bal(t,r,c,i,j)       room cooling balance
 hw_bal(t,r,c,i,j)       hot water balance

 Absr_bal(t,r,c,i,j)     absorbtion refrigerator balance

 HW_trns(t,r,c,i,j)  hot water import capacity
 CW_trns(t,r,c,i,j)  cold water export capacity

 Cost_user(t,r,c)      cost for consumers
 Cost_DHC(t,r)          cost for DHC

 CO2_user(t,r,c)       CO2 from consumers
 CO2_DHC(t,r)           CO2 from DHC

 total_cost(t,r)        total cost
 total_CO2(t,r)         total co2

 total_OBJ         total object

;

**--- 2012 10 3 dynamic expansion ---------------
** 2015 12 17 waste utilization added

equations
   x_cap_G(t,r,k)
   g_hr_cap_G(t,r,c)
   g_bo_cap_G(t,r,k)
   D_gbo_cap_G(t,r)


   RvHP_cap_G(t,r,k)

   SwHP_cap_G(t,r,c)

** 2016 12 19 expanded for GroundHP by Tejima

**2016 12 23 GdHP_cap_G(t,r,c) -->GdHP_cap_G(t,r,k)
   GdHP_cap_G(t,r,k)

   HP_cap_G(t,r,c)
   Absc_cap_G(t,r,k)
   PV_cap_G(t,r,c)
   HX_G(t,r,k)
   HW_tr_cap_G(t,r,c)
   CW_tr_cap_G(t,r,c)

   D_WST_HE_df(t,r,i,j)
;

** 2019 4 26
* Battery

Positive variables
  Chg_Btry(t,r,k,i,j)
  Dsc_Btry(t,r,k,i,j)
  Str_Btry(t,r,k,i,j)
  Cap_Btry(t,r,k)
;

Equation
  Btry_def(t,r,k,i,j)
  Btry_cap_def(t,r,k,i,j)
  Btry_dsc_def(t,r,k,i,j)
  Btry_Const(t,r,k,j)
;

Scalar
 Btry_eff /0.85/
 BtryDscRt /0.5/
;

 Btry_def(t,rx,k,i+1,j)..
  Str_Btry(t,rx,k,i+1,j)=L=Str_Btry(t,rx,k,i,j)
    + i_hours(i)*(Chg_Btry(t,rx,k,i,j) - Dsc_Btry(t,rx,k, i, j) );

 Btry_cap_def(t,rx,k,i,j)..  Str_Btry(t,rx,k,i,j)=L=Cap_Btry(t,rx,k);

 Btry_dsc_def(t,rx,k,i,j)..  Dsc_Btry(t,rx,k,i,j)=L=BtryDscRt*Cap_Btry(t,rx,k);


Btry_Const(t,rx,k,j).. Str_Btry(t,rx,k,"1",j)=L=Str_Btry(t,rx,k,"24",j);

** battery fixed cost --

Scalars
 FC_Btry  /14.4/
 FC_BtryL /4.8/;


scalar  Dpr_cap;
  Dpr_cap=0.95;


scalar  Dpr_cap;
  Dpr_cap=0.95;

   x_cap_G(t+1,rx,k).. x_cap(t+1,rx,k)=G=Dpr_cap*x_cap(t,rx,k);
   g_hr_cap_G(t+1,rx,c).. g_hr_cap(t+1,rx,c)=G=Dpr_cap*g_hr_cap(t,rx,c);
   g_bo_cap_G(t+1,rx,k).. g_bo_cap(t+1,rx,k)=G=Dpr_cap* g_bo_cap(t,rx,k);
   D_gbo_cap_G(t+1,rx).. D_gbo_cap(t+1,rx)=G=Dpr_cap* D_gbo_cap(t,rx);

   HP_cap_G(t+1,rx,c).. HP_cap(t+1,rx,c)=G=Dpr_cap* HP_cap(t,rx,c);

   RvHP_cap_G(t+1,rx,k).. RvHP_cap(t+1,rx,k)=G=Dpr_cap* RvHP_cap(t,rx,k);
   SwHP_cap_G(t+1,rx,c).. SwHP_cap(t+1,rx,c)=G=Dpr_cap* SwHP_cap(t,rx,c);
** 2016 12 19 expanded for GroundHP by Tejima
   GdHP_cap_G(t+1,rx,k).. GdHP_cap(t+1,rx,k)=G=Dpr_cap* GdHP_cap(t,rx,k);

   Absc_cap_G(t+1,rx,k).. Absc_cap(t+1,rx,k)=G=Dpr_cap* Absc_cap(t,rx,k);
   PV_cap_G(t+1,rx,c).. PV_cap(t+1,rx,c)=G=Dpr_cap* PV_cap(t,rx,c);
   HX_G(t+1,rx,k).. HX(t+1,rx,k)=G=Dpr_cap*HX(t,rx,k);
   HW_tr_cap_G(t+1,rx,c).. HW_tr_cap(t+1,rx,c)=G=Dpr_cap*HW_tr_cap(t,rx,c);
   CW_tr_cap_G(t+1,rx,c).. CW_tr_cap(t+1,rx,c)=G=Dpr_cap*CW_tr_cap(t,rx,c);

;
*-------------------------------------------------

* 2015 12 17

  D_WST_HE_df(t,rx,i,j)..  D_WST_H(t,rx,i,j)+D_WST_E(t,rx,i,j)=L=W_HT_1(t,rx,i,j);

x_capacity(t,rx,k,i,j)..
   x_g(t,rx,k,i,j)*cgs_el_ef(rx,k) =L= x_cap(t,rx,k);

* 2012 10 3------------
* 2008 12 5
* 2012 10 4-----------
 gh_capacity(t,rx,c,i,j)..
   g_hr(t,rx,c,i,j)*g_hr_eff =L= g_hr_cap(t,rx,c);

 gb_capacity(t,rx,c,i,j)..
   (g_hw(t,rx,c,i,j) + g_abs(t,rx,c,i,j))*g_bo_eff =L= g_bo_cap(t,rx,c);

Dgb_capacity(t,rx,i,j)..
   D_gbo(t,rx,i,j)*D_gbo_eff =L= D_gbo_cap(t,rx);

 HP_rh_cap(t,rx,c,i,j)..
   HP_hr(t,rx,c,i,j)*COP_h_HP =L= HP_cap(t,rx,c);

 HP_rc_cap(t,rx,c,i,j)..
   HP_cr(t,rx,c,i,j)*COP_c_HP =L= HP_cap(t,rx,c);

 RvHP_rh_cap(t,rx,k,i,j)..
   RvHP_hr(t,rx,k,i,j)*COP_h_RvHP =L= RvHP_cap(t,rx,k)*RV_H_Rto(rx);

 RvHP_rc_cap(t,rx,k,i,j)..
   RvHP_cr(t,rx,k,i,j)*COP_c_RvHP =L= RvHP_cap(t,rx,k)*RV_H_Rto(rx);

** 2016 12 19 expanded for GroundHP by Tejima
 GdHP_rh_cap(t,rx,k,i,j)..
   GdHP_hr(t,rx,k,i,j)*COP_h_GdHP =L= GdHP_cap(t,rx,k);

 GdHP_rc_cap(t,rx,k,i,j)..
   GdHP_cr(t,rx,k,i,j)*COP_c_GdHP =L= GdHP_cap(t,rx,k);

** 2018 11 20

Equations GdHP_UP_def(t,r);

GdHP_UP_def(t,rx)..  sum(k, GdHP_cap(t,rx,k))=L=Gd_H_UL(rx);
  GdHP_cap.UP(t,rx,"DHC")=0.0;


 SwHP_rh_cap(t,rx,c,i,j)..
   SwHP_hr(t,rx,c,i,j)*COP_h_SwHP =L= SwHP_cap(t,rx,c);

 SwHP_rc_cap(t,rx,c,i,j)..
   SwHP_cr(t,rx,c,i,j)*COP_c_SwHP =L= SwHP_cap(t,rx,c);

SW_rhc_UP(t,rx,c,i,j)..
     SwHP_hr(t,rx,c,i,j)+SwHP_cr(t,rx,c,i,j) =L= SW_HT_10(rx,i,j);


 DHP_rh_cap(t,rx,i,j).. DHP_hr(t,rx,i,j)*COP_Dh_HP=L=DHP_cap(t,rx);
 DHP_rc_cap(t,rx,i,j).. DHP_cr(t,rx,i,j)*COP_Dc_HP=L=DHP_cap(t,rx);

* DHP_rh_UP(t,rx,i,j)..  DHP_hr(t,rx,i,j)*COP_Dh_HP=L= W_HT_10(rx,i,j);
* DHP_rc_UP(t,rx,i,j)..  DHP_cr(t,rx,i,j)*COP_Dc_HP=L= W_HT_10(rx,i,j);

 DHP_rhc_UP(t,rx,i,j)..
     DHP_hr(t,rx,i,j)*COP_Dh_HP+DHP_cr(t,rx,i,j)*COP_Dc_HP =L= WTR_HT_10(rx,i,j);

*     DHP_hr(t,rx,i,j)*COP_Dh_HP+DHP_cr(t,rx,i,j)*COP_Dc_HP =L= D_WST_H(t,rx,i,j)+WTR_HT_10(rx,i,j);

 HX_capacity(t,rx,k,i,j)..
   x_g(t,rx,k,i,j)*cgs_ht_ef(rx,k)*cgs_hx_ef(rx,k) =L= HX(t,rx,k);

 Abs_capacity(t,rx,k,i,j)..
   Absc_cr(t,rx,k,i,j)*COP_c_Abs(rx,k) =L= Absc_cap(t,rx,k);


* 2012 10 4------------

** 2014 11 19 modified by Konno
 PV_cap_def(t+1, rx, c).. PV_cap(t+1,rx,c)=E=PV_cap(t,rx,c)+PVN_cap(t+1,rx,c);

 PV_FC_def(t+1,rx,c).. PV_Fcost(t+1,rx,c)=E=PV_Fcost(t,rx,c)+PVN_cap(t+1,rx,c)*PV_FC(t+1);
 PV_FCi_def(rx,c)..    PV_Fcost("1",rx,c)=E= PV_cap("1",rx,c)*PV_FC("1");

* 2011 11 24 expanded by Shimomura
* 2018 11 20 revised to include unused heat sources

 elec_bal(t,rx,c,i,j)..
    y(t,rx,c,i,j)+x_g(t,rx,c,i,j)*cgs_el_ef(rx,c) + x_c_im(t,rx,c,i,j)-x_c_ex(t,rx,c,i,j)

   + Solar_PWr(rx,c,i,j)*PV_cap(t,rx,c)+ Dsc_Btry(t,rx,c,i,j)*Btry_eff

     =e= D_eo(t,rx,c,i,j)+HP_cr(t,rx,c,i,j)+HP_hr(t,rx,c,i,j)+D_ep(t,rx,c,i,j)
         + RvHP_hr(t,rx,c,i,j) + GdHP_hr(t,rx,c,i,j) + SwHP_hr(t,rx,c,i,j)
         + RvHP_cr(t,rx,c,i,j) + GdHP_cr(t,rx,c,i,j) + SwHP_cr(t,rx,c,i,j)
         + Chg_Btry(t,rx,c,i,j)
;

 gas_bal(t,rx,c,i,j)..
  gas_d(t,rx,c,i,j)=e=
     x_g(t,rx,c,i,j)+ g_hw(t,rx,c,i,j) + g_abs(t,rx,c,i,j)+g_hr(t,rx,c,i,j);

 Dgas_bal(t,rx,i,j)..
  gas_d(t,rx,"DHC",i,j)=e= x_g(t,rx,"DHC",i,j)+ D_gbo(t,rx,i,j);

** 2015 12 17 waste pwer generation added

 D_elec_bal(t,rx,i,j)..
    x_g(t,rx,"DHC",i,j)*cgs_el_ef(rx,"DHC") + D_WST_E(t,rx,i,j)*WST_E_eff(rx)

    + WndPwr(rx,i,j) + Dsc_Btry(t,rx,"DHC",i,j)*Btry_eff

      =G= x_c_ex(t,rx,"DHC", i,j)/trns_D_loss - x_c_im(t,rx,"DHC", i,j)
         +sum(c, x_c_im(t,rx,c,i,j)-x_c_ex(t,rx,c,i,j))

         + DHP_hr(t,rx,i,j) + DHP_cr(t,rx,i,j) + Chg_Btry(t,rx,"DHC",i,j)

;

* 2008 12 10

T_elec_bal(t,i,j)..
  TD_el_spl(t,i,j)=E=sum(rx, x_c_ex(t,rx,"DHC", i,j) - x_c_im(t,rx,"DHC", i,j));

cgs_heat_bal(t,rx,c,i,j)..
    x_g(t,rx,c,i,j)*cgs_ht_ef(rx,c)*cgs_hx_ef(rx,c) =G=
       c_h_hw(t,rx,c,i,j)+c_h_rh(t,rx,c,i,j)+c_h_rc(t,rx,c,i,j);

** 20151203 heat transport expanded
** 2015 12 17 waste heat added
** 2019 5 21 modified

 DHC_heat_gen(t,rx,i,j)..

     ( D_WST_H(t,rx,i,j)+
        x_g(t,rx,"DHC",i,j)*cgs_ht_ef(rx,"DHC")+ D_gbo(t,rx,i,j)*D_gbo_eff)
           * cgs_hx_ef(rx,"DHC")
  =E= D_HW_GEN(t,rx,i,j)+Absc_cr(t,rx,"DHC",i,j);

 DHC_hW_bal(t,rx,i,j)..
     D_HW_GEN(t,rx,i,j)
     + sum(rxr, HW_Trnsp(t,rxr,rx,i,j)*HwTrs_Eff ) - sum(rxr, HW_Trnsp(t,rx,rxr,i,j) )

     + DHP_hr(t,rx,i,j)*COP_Dh_HP

  =G= sum(c, D_hr_im(t,rx,c,i,j) + D_hw_im(t,rx,c,i,j));

 DHC_CW_bal(t,rx,i,j)..
     Absc_cr(t,rx,"DHC",i,j)*COP_c_abs(rx,"DHC")
     + sum(rxr, CW_Trnsp(t,rxr,rx,i,j)*CwTrs_Eff ) - sum(rxr, CW_Trnsp(t,rx,rxr,i,j) )

     + DHP_cr(t,rx,i,j)*COP_Dc_HP

  =G= sum(c, D_c_im(t,rx,c,i,j))
;


** 2014 11 13 modified
** initial settings -- power from CGS to utility is PV output only

Scalar
 W_CGS  /0.0/
 W_PV   /1.0/
;

 cgs_e_ex(t,rx,c,i,j)..
  x_c_ex(t,rx,c,i,j)=L=
    W_CGS*x_g(t,rx,c,i,j)*cgs_el_ef(rx,c) +  W_PV * Solar_PWr(rx,c,i,j)*PV_cap(t,rx,c);

* 2014 12 8 2019 9 23 revised

 Dgs_e_ex(t,rx,i,j)..
  x_c_ex(t,rx,"DHC",i,j)=L=
  x_g(t,rx,"DHC",i,j)*cgs_el_ef(rx,"DHC") + sum(c, x_c_ex(t,rx,c,i,j));

*  x_g(t,rx,"DHC",i,j)*cgs_el_ef(rx,"DHC") + sum(c, x_c_ex(t,rx,c,i,j)-x_c_im(t,rx,c,i,j));

 hr_bal(t,rx,c,i,j)..
   D_rh(t,rx,c,i,j) =L=
      c_h_rh(t,rx,c,i,j)+HP_hr(t,rx,c,i,j)*COP_h_hp+g_hr(t,rx,c,i,j)*g_hr_eff
    + D_hr_im(t,rx,c,i,j)*ht_eff + RvHP_hr(t,rx,c,i,j)*COP_h_RvHP+ GdHP_hr(t,rx,c,i,j)*COP_h_GdHP+ SwHP_hr(t,rx,c,i,j)*COP_h_SwHP;

 hc_bal(t,rx,c,i,j)..
   D_rc(t,rx,c,i,j) =L=
      Absc_cr(t,rx,c,i,j)*COP_c_Abs(rx,c)+HP_cr(t,rx,c,i,j)*COP_c_hp
    + D_c_im(t,rx,c,i,j)*ht_eff+ RvHP_cr(t,rx,c,i,j)*COP_c_RvHP+ GdHP_cr(t,rx,c,i,j)*COP_c_GdHP + SwHP_cr(t,rx,c,i,j)*COP_c_SwHP;

 hw_bal(t,rx,c,i,j)..
   D_hw(t,rx,c,i,j) =L=
     c_h_hw(t,rx,c,i,j)+D_hw_im(t,rx,c,i,j)*ht_eff + g_hw(t,rx,c,i,j)*g_bo_eff;

 Absr_bal(t,rx,c,i,j)..
   Absc_cr(t,rx,c,i,j) =L= c_h_rc(t,rx,c,i,j)+g_abs(t,rx,c,i,j)*g_bo_eff;

 CW_trns(t,rx,c,i,j)..  D_c_im(t,rx,c,i,j) =L= CW_tr_cap(t,rx,c);

 HW_trns(t,rx,c,i,j)..  D_hr_im(t,rx,c,i,j)+D_hw_im(t,rx,c,i,j) =L= HW_tr_cap(t,rx,c);

** 2014 11 19 modified by Konno
*  PV cost from  PV_cap(t,r,c)*PV_FC(t) to PV_Fcost

Cost_user(t,rx,c)..

 Cnsm_cost(t,rx,c)*1000. =e=
    x_cap(t,rx,c)*x_FC + g_hr_cap(t,rx,c)*gh_fc +g_bo_cap(t,rx,c)*gb_fc
  + HP_cap(t,rx,c)*HP_FC + Absc_cap(t,rx,c)*ABS_FC + HX(t,rx,c)*HX_FC
  + (HW_tr_cap(t,rx,c)+CW_tr_cap(t,rx,c))*HTR_FC


  + RvHP_cap(t,rx,c)*RvHP_FC

  + GdHP_cap(t,rx,c)*GdHP_FC

  + SwHP_cap(t,rx,c)*SwHP_FC

  + Cap_Btry(t,rx,c)*FC_Btry

  + PV_Fcost(t,rx,c)

  + sum( (i,j),

         (gas_VC(t,rx,c)*gas_d(t,rx,c,i,j)+y(t,rx,c,i,j)*y_prc(t,c,i,j)
           + (x_c_im(t,rx,c,i,j)+x_c_ex(t,rx,c,i,j)) *x_prc(t,i,j)
            +(D_c_im(t,rx,c,i,j)+D_hr_im(t,rx,c,i,j)+D_hr_im(t,rx,c,i,j))*HTR_VC

            )* i_hours(i)*j_days(j)/1000.
          )
     ;

*------- caution 2012 10 10----------
* if s_prc (sales price in FIT case) is larger than x_prc (fee)
* then x_c_im(t,r,DHC,i,j) should be zero as  x_c_im.FX(t,r,DHC,i,j)=0;
* otherwise, DHC will purchse and sell elec from utility -> no solution
*
** expanded 2015 12 5

Cost_DHC(t,rx)..

  DHC_cost(t,rx)*1000.0 =e=

    x_cap(t,rx,"DHC")*d_FC + D_gbo_cap(t,rx)*gb_fc
  + Absc_cap(t,rx,"DHC")*ABS_FC + HX(t,rx,"DHC")*HX_FC

  + DHP_cap(t,rx)*DHP_FC

  + Cap_Btry(t,rx,"DHC")*FC_BtryL

  +  sum( (i,j),

             (  gas_VC(t,rx,"DHC")*gas_d(t,rx,"DHC",i,j)
                + x_c_im(t,rx,"DHC",i,j)*y_prc(t,"DHC",i,j)
                - x_c_ex(t,rx,"DHC",i,j)*s_prc(t,i,j)

                + sum(rxr,  Hw_prc(t,i,j)*HW_Trnsp(t,rxr,rx,i,j)
                          +Cw_prc(t,i,j)*CW_Trnsp(t,rxr,rx,i,j) )

             )* i_hours(i)*j_days(j)/1000.
          )
 ;


CO2_user(t,rx,c)..
 Cnsm_cO2(t,rx,c) =e=
   sum( (i,j),
        ( CO2_gas*gas_d(t,rx,c,i,j) + y(t,rx,c,i,j)*CO2_Elec(t,rx,i,j) )
          * i_hours(i)*j_days(j)/1000.
      );

CO2_DHC(t,rx)..
 DHC_CO2(t,rx) =e=
   sum( (i,j),
        (  CO2_gas*gas_d(t,rx,"DHC",i,j)- CO2_Elec(t,rx,i,j)*x_c_ex(t,rx,"DHC",i,j))
          * i_hours(i)*j_days(j)/1000.

      );

total_cost(t,rx)..
   T_Cost(t,rx) =e= sum(c, Cnsm_cost(t,rx,c))+DHC_Cost(t,rx);

total_CO2(t,rx)..
   T_CO2(t,rx) =e= sum(c, Cnsm_CO2(t,rx,c))+DHC_CO2(t,rx)
     +0.001*sum( (i,j), sum(c, x_c_im(t,rx,c,i,j)+x_c_ex(t,rx,c,i,j)));

total_OBJ..
   T_OBJ =e=
     sum(T,
        (0.95**5)**(ord(t)-1)*(
            wgt_co2*sum(rx, T_CO2(t,rx)) + (1-wgt_co2)*sum(rx,T_Cost(t,rx))
        )
     );


* 2012 11 20 PV installation lower bound is imposed

Parameter PV_LOW(T)
/1 0
* 2 0
* 3 0
* 4 0
* 5 0

/;


equation PV_LO_DEF(T);

PV_LO_DEF(T).. sum(rx, sum(c, PV_cap(t,rx,c))) =G=PV_LOW(T);

** 2019 5 27


model test /ALL/;

OPTION ITERLIM  = 99900;
OPTION RESLIM   = 99999;
OPTION SOLPRINT = OFF;
OPTION LIMROW   = 0;
OPTION LIMCOL   = 0;
OPTION SYSOUT = OFF;


FILE FSAVE /Koto151_Case0_2dg.CSV/;
PUT FSAVE;
FSAVE.PC=5;
FSAVE.PW=4096;

Put "Case-0 ; Conventional system"/;

 x_cap.up(t,r,k)=0;
 x_c_ex.UP(t,r,c,i,j)=0;
 x_c_im.UP(t,r,c,i,j)=0;

 D_gbo_cap.UP(t,r)=0.0;
 DHP_cap.UP(t,r)=0.0;

 HW_tr_cap.UP(t,r,c)=0.0;
 CW_tr_cap.UP(t,r,c)=0.0;

 HW_Trnsp.UP(t,r,rr,i,j)=0.0;
 CW_Trnsp.UP(t,r,rr,i,j)=0.0;

 HW_Trnsp.FX(t,r,rr,i,j)$(Heat_Rgn(r,rr) LT 1)=0.0;
 HW_Trnsp.FX(t,r,rr,i,j)$(Heat_Rgn(r,rr) GE 2)=0.0;

 CW_Trnsp.FX(t,r,rr,i,j)$(Heat_Rgn(r,rr) LT 1)=0.0;
 CW_Trnsp.FX(t,r,rr,i,j)$(Heat_Rgn(r,rr) GE 2)=0.0;

 Hw_prc(t,i,j)=0.5;
 Cw_prc(t,i,j)=0.5;

 PV_cap.UP(t,r,c)=0.0;

 RvHP_cap.UP(t,r,k)=0.0;
 GdHP_cap.UP(t,r,k)=0.0;
 SwHP_cap.UP(t,r,c)=0.0;


  Chg_Btry.UP(t,r,k,i,j)=0.0;
  Dsc_Btry.UP(t,r,k,i,j)=0.0;
  Str_Btry.UP(t,r,k,i,j)=0.0;
  Cap_Btry.UP(t,r,k)=0.0;


option iterlim=9999999;
option reslim=9999999;

test.optfile=1;

$ONTEXT

rx(r)=no;

Loop(r, 
  rx(r)=yes;

solve test minimizing T_OBJ using LP;

  rx(r)=no;
);

rx(r)=yes;

$OFFTEXT

solve test minimizing T_OBJ using LP;

 display y.L, gas_d.L, x_g.L, Cnsm_cO2.l, T_CO2.L, x_c_ex.L;
 display x_c_im.l, x_c_ex.l, dhc_co2.l;


parameters

 D_CO2_out(t,r,i,j)
 E_CO2_utl(t,r,i,j)

 Elc_r_Dmd(t,r,i,j)
 Elc_T_Dmd(t,i,j)

 PV_Output(t,r,c,i,j)
* 2011 12 22
  PV_Out_T(t,r,c)
  UtilElc_T(t,r,c)

*2012-------------------------

ELC_D(t,r,c,i,j)
ELC_Out_T(t,r,c)
Elc_Dmd(t,i,j)
PV_Out(t,i,j)

*2015 12 5 ---------------------------
* thermal transportation import from other regions

 Hw_Trs_TL(t,r,i,j)
 Cw_Trs_TL(t,r,i,j)

;

 Hw_Trs_TL(t,r,i,j)=sum(rr, HW_Trnsp.L(t,rr,r,i,j)*HwTrs_Eff);
 Cw_Trs_TL(t,r,i,j)=sum(rr, CW_Trnsp.L(t,rr,r,i,j)*CwTrs_Eff);

 D_CO2_out(t,r,i,j)=x_g.L(t,r,"DHC",i,j)*CO2_gas;

 E_CO2_utl(t,r,i,j)=CO2_Elec(t,r,i,j)*x_c_ex.L(t,r,"DHC",i,j);

display D_CO2_out, E_CO2_utl;


Parameters wrk1(t,r),wrk2(t,r),wrk3(t,r),wrk4(t,r),wrk5(t,r),wrk6(t,r),wrk7(t,r),wrk8(t,r),wrk9(t,r),wrk10(t,r),wrk11(t,r),wrk12(t,r),wrk13(t,r);


$INCLUDE Koto151RS4_Out.gms


FILE FSAVE1 /Koto151_Case1_2dg.CSV/;
PUT FSAVE1;
FSAVE1.PC=5;
FSAVE1.PW=4096;

Put "Case-1 : PV, CGS and Battery -- Stand alone type "/;


 x_cap.up(t,r,C)=INF;
 x_c_ex.UP(t,r,c,i,j)=0;
 x_c_im.UP(t,r,c,i,j)=0;

 D_gbo_cap.UP(t,r)=0.0;
 DHP_cap.UP(t,r)=0.0;

 HW_tr_cap.UP(t,r,c)=0.0;
 CW_tr_cap.UP(t,r,c)=0.0;

 HW_Trnsp.UP(t,r,rr,i,j)=0.0;
 CW_Trnsp.UP(t,r,rr,i,j)=0.0;

 HW_Trnsp.FX(t,r,rr,i,j)$(Heat_Rgn(r,rr) LT 1)=0.0;
 HW_Trnsp.FX(t,r,rr,i,j)$(Heat_Rgn(r,rr) GE 2)=0.0;

 CW_Trnsp.FX(t,r,rr,i,j)$(Heat_Rgn(r,rr) LT 1)=0.0;
 CW_Trnsp.FX(t,r,rr,i,j)$(Heat_Rgn(r,rr) GE 2)=0.0;

 PV_cap.UP(t,r,c)=PV_Area(r,c);;

 RvHP_cap.UP(t,r,k)=0.0;
 GdHP_cap.UP(t,r,k)=0.0;
 SwHP_cap.UP(t,r,c)=0.0;

  Chg_Btry.UP(t,r,c,i,j)=INF;
  Dsc_Btry.UP(t,r,c,i,j)=INF;
  Str_Btry.UP(t,r,c,i,j)=INF;
  Cap_Btry.UP(t,r,c)=INF;

option iterlim=9999999;
option reslim=9999999;

test.optfile=1;

* $ONTEXT

rx(r)=no;

Loop(r, 
  rx(r)=yes;

solve test minimizing T_OBJ using LP;

  rx(r)=no;
);

rx(r)=yes;

* $OFFTEXT

solve test minimizing T_OBJ using LP;

 Hw_Trs_TL(t,r,i,j)=sum(rr, HW_Trnsp.L(t,rr,r,i,j)*HwTrs_Eff);
 Cw_Trs_TL(t,r,i,j)=sum(rr, CW_Trnsp.L(t,rr,r,i,j)*CwTrs_Eff);

 D_CO2_out(t,r,i,j)=x_g.L(t,r,"DHC",i,j)*CO2_gas;
 E_CO2_utl(t,r,i,j)=CO2_Elec(t,r,i,j)*x_c_ex.L(t,r,"DHC",i,j);

$INCLUDE Koto151RS4_Out.gms

**

FILE FSAVE2 /Koto151_Case2_2dg.CSV/;
PUT FSAVE2;
FSAVE2.PC=5;
FSAVE2.PW=4096;


Put "Case-2 : District energy transportation"/;

 x_cap.up(t,r,k)=INF;
 x_c_ex.UP(t,r,c,i,j)=INF;
 x_c_im.UP(t,r,c,i,j)=INF;

 D_gbo_cap.UP(t,r)=INF;
 DHP_cap.UP(t,r)=INF;

 HW_tr_cap.UP(t,r,c)=INF;
 CW_tr_cap.UP(t,r,c)=INF;

 HW_Trnsp.UP(t,r,rr,i,j)=0.0;
 CW_Trnsp.UP(t,r,rr,i,j)=0.0;

 HW_Trnsp.FX(t,r,rr,i,j)$(Heat_Rgn(r,rr) LT 1)=0.0;
 HW_Trnsp.FX(t,r,rr,i,j)$(Heat_Rgn(r,rr) GE 2)=0.0;

 CW_Trnsp.FX(t,r,rr,i,j)$(Heat_Rgn(r,rr) LT 1)=0.0;
 CW_Trnsp.FX(t,r,rr,i,j)$(Heat_Rgn(r,rr) GE 2)=0.0;

 PV_cap.UP(t,r,c)=PV_Area(r,c);;

 RvHP_cap.UP(t,r,k)=INF;
 GdHP_cap.UP(t,r,k)=INF;
 SwHP_cap.UP(t,r,c)=INF;

  Chg_Btry.UP(t,r,k,i,j)=INF;
  Dsc_Btry.UP(t,r,k,i,j)=INF;
  Str_Btry.UP(t,r,k,i,j)=INF;
  Cap_Btry.UP(t,r,k)=INF;


option iterlim=9999999;
option reslim=9999999;

test.optfile=1;

rx(r)=no;

Loop(r, 
  rx(r)=yes;

solve test minimizing T_OBJ using LP;

  rx(r)=no;
);

rx(r)=yes;

solve test minimizing T_OBJ using LP;

 Hw_Trs_TL(t,r,i,j)=sum(rr, HW_Trnsp.L(t,rr,r,i,j)*HwTrs_Eff);
 Cw_Trs_TL(t,r,i,j)=sum(rr, CW_Trnsp.L(t,rr,r,i,j)*CwTrs_Eff);

 D_CO2_out(t,r,i,j)=x_g.L(t,r,"DHC",i,j)*CO2_gas;
 E_CO2_utl(t,r,i,j)=CO2_Elec(t,r,i,j)*x_c_ex.L(t,r,"DHC",i,j);

$INCLUDE Koto151RS4_Out.gms

**

FILE FSAVE3 /Koto151_Case3_2dg.CSV/;
PUT FSAVE3;
FSAVE3.PC=5;
FSAVE3.PW=4096;


Put "Case-3 : District energy transportation with Unutilized sources"/;

 x_cap.up(t,r,k)=INF;
 x_c_ex.UP(t,r,c,i,j)=INF;
 x_c_im.UP(t,r,c,i,j)=INF;

 D_gbo_cap.UP(t,r)=INF;
 DHP_cap.UP(t,r)=INF;

 HW_tr_cap.UP(t,r,c)=INF;
 CW_tr_cap.UP(t,r,c)=INF;

 HW_Trnsp.UP(t,r,rr,i,j)=0.0;
 CW_Trnsp.UP(t,r,rr,i,j)=0.0;

 HW_Trnsp.FX(t,r,rr,i,j)$(Heat_Rgn(r,rr) LT 1)=0.0;
 HW_Trnsp.FX(t,r,rr,i,j)$(Heat_Rgn(r,rr) GE 2)=0.0;

 CW_Trnsp.FX(t,r,rr,i,j)$(Heat_Rgn(r,rr) LT 1)=0.0;
 CW_Trnsp.FX(t,r,rr,i,j)$(Heat_Rgn(r,rr) GE 2)=0.0;

 PV_cap.UP(t,r,c)=PV_Area(r,c);

 RvHP_cap.UP(t,r,k)=INF;
 GdHP_cap.UP(t,r,k)=INF;
 SwHP_cap.UP(t,r,c)=INF;


option iterlim=9999999;
option reslim=9999999;

test.optfile=1;

rx(r)=no;

Loop(r, 
  rx(r)=yes;

solve test minimizing T_OBJ using LP;

  rx(r)=no;
);

rx(r)=yes;

solve test minimizing T_OBJ using LP;

 Hw_Trs_TL(t,r,i,j)=sum(rr, HW_Trnsp.L(t,rr,r,i,j)*HwTrs_Eff);
 Cw_Trs_TL(t,r,i,j)=sum(rr, CW_Trnsp.L(t,rr,r,i,j)*CwTrs_Eff);

 D_CO2_out(t,r,i,j)=x_g.L(t,r,"DHC",i,j)*CO2_gas;
 E_CO2_utl(t,r,i,j)=CO2_Elec(t,r,i,j)*x_c_ex.L(t,r,"DHC",i,j);

$INCLUDE Koto151RS4_Out.gms

**

FILE FSAVE4 /Koto151_Case4_2dg.CSV/;
PUT FSAVE4;
FSAVE4.PC=5;
FSAVE4.PW=4096;


Put "Case-4 : Inter regional energy transportation with Unutilized sources"/;

 x_cap.up(t,r,k)=INF;
 x_c_ex.UP(t,r,c,i,j)=INF;
 x_c_im.UP(t,r,c,i,j)=INF;

 x_c_ex.UP(t,r,"DHC",i,j)=INF;

 D_gbo_cap.UP(t,r)=INF;
 DHP_cap.UP(t,r)=INF;

 HW_tr_cap.UP(t,r,c)=INF;
 CW_tr_cap.UP(t,r,c)=INF;

 HW_Trnsp.UP(t,r,rr,i,j)=INF;
 CW_Trnsp.UP(t,r,rr,i,j)=INF;

 HW_Trnsp.FX(t,r,rr,i,j)$(Heat_Rgn(r,rr) LT 1)=0.0;
 HW_Trnsp.FX(t,r,rr,i,j)$(Heat_Rgn(r,rr) GE 2)=0.0;

 CW_Trnsp.FX(t,r,rr,i,j)$(Heat_Rgn(r,rr) LT 1)=0.0;
 CW_Trnsp.FX(t,r,rr,i,j)$(Heat_Rgn(r,rr) GE 2)=0.0;

 PV_cap.UP(t,r,c)=PV_Area(r,c);

 RvHP_cap.UP(t,r,k)=INF;
 GdHP_cap.UP(t,r,k)=INF;
 SwHP_cap.UP(t,r,c)=INF;


option iterlim=9999999;
option reslim=9999999;

test.optfile=1;

solve test minimizing T_OBJ using LP;

 Hw_Trs_TL(t,r,i,j)=sum(rr, HW_Trnsp.L(t,rr,r,i,j)*HwTrs_Eff);
 Cw_Trs_TL(t,r,i,j)=sum(rr, CW_Trnsp.L(t,rr,r,i,j)*CwTrs_Eff);

 D_CO2_out(t,r,i,j)=x_g.L(t,r,"DHC",i,j)*CO2_gas;
 E_CO2_utl(t,r,i,j)=CO2_Elec(t,r,i,j)*x_c_ex.L(t,r,"DHC",i,j);

$INCLUDE Koto151RS4_Out.gms




